
SurfaceOut surfaceFunction(in VertexIn In)
{
  SurfaceOut Out = createSurfaceOut();

#if defined(BASE_MATERIAL_VERTEX_NORMAL0)
  vec3 normal = normalize(In.Normal);
  Out.Normal = In.Facing ? normal : -normal;
#endif

  Out.Color = vec4(In.Color, 1.0);

  return Out;
}
