precision highp float;

attribute vec2 a_POSITION0;
attribute vec2 a_TEXCOORD0;
attribute vec4 a_COLOR0;
attribute vec4 a_COLOR1;

uniform mat4 projectionMatrix;
uniform int showAlpha;

varying vec4 vPosition;
varying vec4 vColor;
varying vec2 vTexCoord;

void main()
{
  gl_Position = projectionMatrix * vec4(a_POSITION0.xy, 0.0, 1.0);
  vColor = a_COLOR0;
  if (showAlpha == 1) vColor.a = -1.0;
  vTexCoord = a_TEXCOORD0;
}
