#version 300 es
precision highp float;
precision highp int;

uniform ImguiBuffer
{
  mat4 ProjectionMatrix;
  int ShowAlpha;
  int TexMode;
  int Offset;
};

in vec4 a_POSITION;
in vec2 a_TEXCOORD;
in vec4 a_COLOR;

out vec4 col;
out vec2 uv;

void main()
{
#if 0
  // HLSL version convertes from sRGB
  col = vec4(pow(abs(a_COLOR.rgb), vec3(2.2)), a_COLOR.a);
#else
  col = a_COLOR;
#endif
  uv = a_TEXCOORD;
  gl_Position = ProjectionMatrix * vec4(a_POSITION.xy, 0.0, 1.0);
}
