void main(/*VertexIn In, float4 screenPos : SV_Position*/)
{
  VertexIn In = importVaryings();
  SurfaceOut surface = SURFACE_FUNCTION(In);

#ifdef COGS_ALPHA_TEST_DISCARD
  if (surface.Color.a < alphaThreshold()) discard;
#endif

  float id = float(surface.objectId);
  vec4 color;
  color.r = (256.0 * fract(id / 256.0) + 0.4)/ 255.0;
  id = floor(id / 256.0);
  color.g = (256.0 * fract(id / 256.0) + 0.4)/ 255.0;
  id = floor(id / 256.0);
  color.b = (256.0 * fract(id / 256.0) + 0.4)/ 255.0;
  id = floor(id / 256.0);
  color.a = (256.0 * fract(id / 256.0) + 0.4)/ 255.0;
  gl_FragColor = color;
}
