#include "Random.hlsl"

struct MyVertexOut
{
  float4 Color : TEXCOORD8;
  VertexOut vertexOut;
};


MyVertexOut main(VertexIn In)
{
  VertexOut Out = VERTEX_FUNCTION(In);

  Out.ViewSpacePosition = mul(Out.WorldPosition, viewMatrix);


  MyVertexOut MyOut = (MyVertexOut)0;
  MyOut.vertexOut = Out;

  uint id = objectId;
  /* if (instanceIdShift < 32u) { */
  /*   id = id | (Out.instanceId << instanceIdShift); */
  /* } */

#ifdef COGS_OBJECTID_COLORIZE
  id = wangHash(id);
  MyOut.Color = float4((1.0 / 255)*((id >> 0) & 255),
                       (1.0 / 255)*((id >> 8) & 255),
                       (1.0 / 255)*((id >> 16) & 255),
                       1.0);
#else
  MyOut.Color = float4((1.0 / 255)*((id >> 0) & 255),
                       (1.0 / 255)*((id >> 8) & 255),
                       (1.0 / 255)*((id >> 16) & 255),
                       1.0 /*(1.0 / 255)*((id >> 24) & 255)*/);

#endif
  return MyOut;
}
