//#if defined(COGS_TRANSPARENT_SHADOWS)
//#include "BlueNoise.hlsl"
//#endif
#include "Bayer.es30.glsl"

void main()
{
  VertexIn In = importIn();

#if defined(COGS_ALPHA_TEST_DISCARD) || defined(COGS_ALPHA_TO_COVERAGE) || defined(COGS_TRANSPARENT_SHADOWS)
  SurfaceOut surface = SURFACE_FUNCTION(In);
#endif

#if defined(COGS_ALPHA_TEST_DISCARD) || defined(COGS_ALPHA_TO_COVERAGE)
  if (surface.Color.a < alphaThreshold) discard;
#endif

#if defined(COGS_TRANSPARENT_SHADOWS)
//  int2 noise_pos = ScreenPos.xy;
//  //noise_pos += int2(objectId&0x3f, objectId>>6);
//  float dither = blueNoiseStable(noise_pos);
//  if (surface.Color.a < dither && surface.Color.a != 1.0) discard;
  float dither = (1.0 / 16.0)*float(bayer4(uvec2(gl_FragCoord.xy)));
  if (surface.Color.a < dither && surface.Color.a != 1.0) discard;
#endif
}
