SurfaceOut surfaceFunction(in VertexIn vertexIn)
{
  SurfaceOut surfaceOut;

  vec4 color = vec4(0.0);

  float r = length(vertexIn.texCoord);

  float q = r - 0.5 * pointSizes.x;

  if (q <= 0.0) {
    float b = clamp(q + pointSizes.y + 0.01, 0.0, 1.0);
    color = mix(diffuseColor, outlineColor, b);

    if (-1.0 < q) {
      color.a = (-q) * color.a;
    }
  } else {
    discard;
  }

  surfaceOut.Color = color;

  return surfaceOut;
}
