SurfaceOut surfaceFunction(VertexIn input)
{
  SurfaceOut Out = (SurfaceOut)0;

  float4 color = (float4)0;

  float r = length(input.texCoord);

  float q = r - 0.5f * pointSizes.x;

  if (q <= 0.0) {
    float b = clamp(q + pointSizes.y + 0.01, 0.0, 1.0);
    color = lerp(diffuseColor, outlineColor, b);

    if (-1.0 < q) {
      color.a = (-q) * color.a;
    }
  } else {
    discard;
  }

  Out.Color = color;

  return Out;
}
