#ifndef COGS_CORE_RANDOM_HLSL
#define COGS_CORE_RANDOM_HLSL

uint wangHash(uint seed)
{
  seed = (seed ^ 61) ^ (seed >> 16);
  seed *= 9;
  seed = seed ^ (seed >> 4);
  seed *= 0x27d4eb2d;
  seed = seed ^ (seed >> 15);
  return seed;
}

float rand(inout uint state)
{
  state = 1664525 * state + 1013904223;
  return (1.0 / 4294967296.0)*state;
}


#endif