SurfaceOut surfaceFunction(VertexIn In)
{
  SurfaceOut Out = (SurfaceOut)0;

  float4 logColor = colorMap.Sample(colorMapSampler, In.TexCoord) * parameters.x + float4(diffuseColor.rgb * (1.0 - parameters.x), diffuseColor.a);

  Out.Color = float4(0, 0, 0, logColor.a);
  Out.Emissive = logColor.rgb;
  Out.Normal = float3(1, 1, 1);

  return Out;
}
