
SurfaceOut surfaceFunction(in VertexIn In)
{
  SurfaceOut Out = (SurfaceOut)0;

#if defined(BASE_MATERIAL_VERTEX_NORMAL0)
  float3 normal = normalize(In.Normal);
  Out.Normal = In.Facing ? normal : -normal;
#endif

  Out.Color = float4(In.Color, 1.0);

  return Out;
}
