VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = (VertexOut)0;

  Out.WorldPosition = mul(positionTypeAsFloat4(In.Position), worldMatrix);;
  Out.Position = mul(Out.WorldPosition, worldToClipMatrix);
  Out.Normal = mul(In.Normal, (float3x3)worldMatrix);
#ifdef COGS_CLOSED_TRANSPARENT_MATERIAL_DIFFUSE_MAP
  Out.TexCoord = In.TexCoord;
#endif
  return Out;
}
