SurfaceOut invokeMaterial(VertexIn In)
{
#if defined(COGS_CLIP_IN_PIXEL_SHADER)

#if defined(COGS_CLIPSHAPE_CUBE)
  if ((In.Clip0.x < 0.0) ||
      (In.Clip0.y < 0.0) ||
      (In.Clip0.z < 0.0) ||
      (In.Clip0.w < 0.0) ||
      (In.Clip1.x < 0.0) ||
      (In.Clip1.y < 0.0))
  {
    discard;
  }
#elif defined(COGS_CLIPSHAPE_INVERTED_CUBE)
  if ((0.0 < In.Clip0.x) && 
      (0.0 < In.Clip0.y) &&
      (0.0 < In.Clip0.z) &&
      (0.0 < In.Clip0.w) &&
      (0.0 < In.Clip1.x) &&
      (0.0 < In.Clip1.y))
  {
    discard;
  }
#endif

#endif
  SurfaceOut Out = MATERIAL_SURFACE_FUNCTION(In);

  return Out;
}
